<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset="UTF-8">
	<title>Ejercicio 1</title>
</head>
<body>

	<script type="text/javascript">

		//Ejercicio 1
		var anObject = {
			foo: 'bar',
			length: 'interesting',
			'0': 'zero!',
			'1': 'one!'
		};
		var anArray = ['zero.', 'one.']

		console.log("Ejercicio 1");
		console.log(anArray[0], anObject[0]);
		console.log(anArray[1], anObject[1]);
		console.log(anArray.length, anObject.length);
		console.log(anArray.foo, anObject.foo);

		console.log(typeof anArray == 'object', typeof anObject == 'object');
		console.log(anArray instanceof Object, anObject instanceof Object);
		console.log(anArray instanceof Array, anObject instanceof Array);
		console.log(Array.isArray(anArray), Array.isArray(anObject));

		//Ejercicio 2
		var obj = {
			a: "hello",
			b: "this is",
			c: "javascript!"
		};
		console.log("Ejercicio 2");
		console.log(Object.values(obj));

		//Ejercicio 3

		document.body.onload = numPar;
		function numPar(){
			document.write("Ejercicio 3");
			for(var numero=0; numero<=98; numero++){
					if (numero % 2 == 0){
							document.write("<p>"+numero + "</p>");
					}
			}
		}

		//Ejercicio 4
		let zero = 0;
		console.log("Ejercicio 4");
		function multiply(x) { return x * 2;}
		function add(a =1 + zero, b = a, c = b + a, d = multiply(c)){
			/*
			console.log(a); //1 -- 3 ---- 2 -- 1 --- 1
			console.log(b); //1 -- 3 ---- 7 -- 2 --- 2
			console.log(c); //2 -- 6 ---- 9 -- 5 --- 5
			console.log(d); //4 -- 12 -- 18 -- 10 -- 10
			*/
			console.log((a + b + c), d);
		}
		
		add(1); //a
		add(3); //a
		add(2, 7); //a ---- b
		add(1, 2, 5); // a --- b --- c
		add(1, 2, 5, 10); // a -- b -- c -- d

		//Ejercicio 5
		class MyClass {
			constructor() {
				this.names_ = [];}
				
			set name (value) { //asigna un nuevo valor
				this.names_.push(value);}

			get name() { //obtiene el ultimo valor del arreglo
				return this.names_[this.names_.length -1];}
		}

		const myClassInstance = new MyClass();
		myClassInstance.name = 'Joe';
		myClassInstance.name = 'Bob';

		console.log("Ejercicio 5");
		console.log(myClassInstance.name); 
		console.log(myClassInstance.names_);

		//Ejercicio 6
		const classInstance = new class {
			get prop() {
				return 5;
			}};

		classInstance.prop = 10;
		console.log("Ejercicio 6");
		console.log(classInstance.prop);

		//Ejercicio 7
				class Queue {

		  constructor () { 
		    const list = [];
		    this.enqueue = function (type) { 
		              
		      list.push(type);
		      return type;
		    };
		    this.dequeue = function () { 
		    
		      return list.shift();
		    };
		  }
		}

		var q = new Queue;            
		                              
		q.enqueue(9);                 
		q.enqueue(8);                 
		q.enqueue(7);                 
		
		console.log("Ejercicio 7");                              
		console.log(q.dequeue());     // 9 
		console.log(q.dequeue());     // 8
		console.log(q.dequeue());     // 7
		console.log(q);               // Queue
		console.log(Object.keys(q));  // ["enqueue","dequeue"]
		
	</script>
	
</body>
</html>

